## GMemoryMonitor GMemoryMonitor — Memory usage monitor |

## Functions

GMemoryMonitor * | g_memory_monitor_dup_default ()

## Signals

void | low-memory-warning | Run Last

## Types and Values

| GMemoryMonitor
struct | GMemoryMonitorInterface
enum | GMemoryMonitorWarningLevel
#define | G_MEMORY_MONITOR_EXTENSION_POINT_NAME

## Object Hierarchy

        GEnum
        ╰── GMemoryMonitorWarningLevel
        GInterface
        ╰── GMemoryMonitor

## Prerequisites

GMemoryMonitor requires GInitable and GObject.

## Includes

    #include <gio/gio.h>

## Description

GMemoryMonitor will monitor system memory and suggest to the application when to free memory so as to leave more room for other applications. It is implemented on Linux using the Low Memory Monitor (API documentation).

There is also an implementation for use inside Flatpak sandboxes.

Possible actions to take when the signal is received are:

- Free caches

- Save files that haven't been looked at in a while to disk, ready to be reopened when needed

- Run a garbage collection cycle

- Try and compress fragmented allocations

- Exit on idle if the process has no reason to stay around

- Call `malloc_trim(3)` to return cached heap pages to the kernel (if supported by your libc)

Note that some actions may not always improve system performance, and so should be profiled for your application. ``malloc_trim()``, for example, may make future heap allocations slower (due to releasing cached heap pages back to the kernel).

See GMemoryMonitorWarningLevel for details on the various warning levels.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    static void
    warning_cb (GMemoryMonitor *m, GMemoryMonitorWarningLevel level)
    {
      g_debug ("Warning level: %d", level);
      if (warning_level > G_MEMORY_MONITOR_WARNING_LEVEL_LOW)
        drop_caches ();
    }

    static GMemoryMonitor *
    monitor_low_memory (void)
    {
      GMemoryMonitor *m;
      m = g_memory_monitor_dup_default ();
      g_signal_connect (G_OBJECT (m), "low-memory-warning",
                        G_CALLBACK (warning_cb), NULL);
      return m;
    }

Don't forget to disconnect the “low-memory-warning” signal, and unref the GMemoryMonitor itself when exiting.

## Functions

### g_memory_monitor_dup_default ()

    GMemoryMonitor *
    g_memory_monitor_dup_default (void);

Gets a reference to the default GMemoryMonitor for the system.

#### Returns

a new reference to the default GMemoryMonitor.

[not nullable][transfer full]

Since: 2.64

## Types and Values

### GMemoryMonitor

    typedef struct _GMemoryMonitor GMemoryMonitor;

GMemoryMonitor monitors system memory and indicates when the system is low on memory.

Since: 2.64

### struct GMemoryMonitorInterface

    struct GMemoryMonitorInterface {
      void     (*low_memory_warning)  (GMemoryMonitor             *monitor,
                                       GMemoryMonitorWarningLevel  level);
    };

The virtual function table for GMemoryMonitor.

#### Members

`low_memory_warning` () | the virtual function pointer for the “low-memory-warning” signal. |

Since: 2.64

### enum GMemoryMonitorWarningLevel

Memory availability warning levels.

Note that because new values might be added, it is recommended that applications check GMemoryMonitorWarningLevel as ranges, for example:

    1
    2
    if (warning_level > G_MEMORY_MONITOR_WARNING_LEVEL_LOW)
      drop_caches ();

#### Members

G_MEMORY_MONITOR_WARNING_LEVEL_LOW | Memory on the device is low, processes should free up unneeded resources (for example, in-memory caches) so they can be used elsewhere. |
G_MEMORY_MONITOR_WARNING_LEVEL_MEDIUM | Same as `G_MEMORY_MONITOR_WARNING_LEVEL_LOW` but the device has even less free memory, so processes should try harder to free up unneeded resources. If your process does not need to stay running, it is a good time for it to quit. |
G_MEMORY_MONITOR_WARNING_LEVEL_CRITICAL | The system will soon start terminating processes to reclaim memory, including background processes. |

Since: 2.64

### G_MEMORY_MONITOR_EXTENSION_POINT_NAME

    #define G_MEMORY_MONITOR_EXTENSION_POINT_NAME "gio-memory-monitor"

Extension point for memory usage monitoring functionality. See Extending GIO.

Since: 2.64

## Signal Details

### The `“low-memory-warning”` signal

    void
    user_function (GMemoryMonitor            *monitor,
                   GMemoryMonitorWarningLevel level,
                   gpointer                   user_data)

Emitted when the system is running low on free memory. The signal handler should then take the appropriate action depending on the warning level. See the GMemoryMonitorWarningLevel documentation for details.

#### Parameters

monitor | a GMemoryMonitor |
level | the GMemoryMonitorWarningLevel warning level |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since: 2.64